package it.micegroup.gestioneferie.pianificazioneferie.entity;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.PrePersist;
import javax.persistence.PreUpdate;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.FetchType;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.annotation.JsonBackReference;
import javax.persistence.ManyToOne;
import javax.validation.constraints.NotNull;

import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.Getter;
import lombok.AllArgsConstructor;

import javax.persistence.Table;

import org.apache.commons.lang3.StringUtils;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.hibernate.Hibernate;
import java.util.Objects;

import it.micegroup.gestioneferie.pianificazioneferie.entity.DpianificFerieAmmtoKey;

import it.micegroup.gestioneferie.libs.entity.BaseEntity;
import it.micegroup.voila2runtime.utils.EntityUtils;

@NoArgsConstructor

@Getter
@Setter
@Entity
@Table(name = "D_PERIODI_AMMTO_PF")
public class DperiodiAmmtoPf extends BaseEntity implements Serializable {

	// Generated SERIAL VERSION UID
	private static final long serialVersionUID = ;

	@SuppressWarnings("unused")
	private static final Logger LOGGER = LogManager.getLogger(DperiodiAmmtoPf.class);

	// ATTRIBUTES
	@Column(name = "SEQU_ID_PERIODO_AMMTO_PF"
	, columnDefinition=""
	)
	private  sequIdPeriodoAmmtoPf;
	@Column(name = "DATA_INIZIO_PIANIFICAZIONE"
	, columnDefinition="DATE"
	)
	private Date dataInizioPianificazione;
	@Column(name = "DATA_FINE_PIANIFICAZIONE", columnDefinition = "DATE")
	private Date dataFinePianificazione;
	@NotNull

	@Column(name = "FLAG_NESSUNA_RICHIESTA_FERIE", columnDefinition = "VARCHAR(1)")
	private String flagNessunaRichiestaFerie;
	@NotNull

	@Column(name = "FK_PIANIFIC_FERIE_AMMTO", columnDefinition = "NUMBER(15)")
	private Long fkPianificFerieAmmto;
	@NotNull

	@Column(name = "FLAG_ELIMINATO", columnDefinition = "VARCHAR(1)")
	private String flagEliminato;
	@NotNull

	@Column(name = "UTENTE_ULTIMA_MODIFICA", columnDefinition = "VARCHAR(50)")
	private String utenteUltimaModifica;
	@NotNull

	@Column(name = "DATA_ULTIMA_MODIFICA", columnDefinition = "DATE")
	private Date dataUltimaModifica;
	@NotNull

	@Column(name = "DATA_INIZIO_RECORD", columnDefinition = "DATE")
	private Date dataInizioRecord;
	@NotNull

	@Column(name = "DATA_FINE_RECORD", columnDefinition = "DATE")
	private Date dataFineRecord;

	// IMPORTED PARENTS

	// CONSTRUCTORS
	public DperiodiAmmtoPf(String objectKey) {
		super();
		setObjectKey(objectKey);
	}

	public DperiodiAmmtoPf(DperiodiAmmtoPfKey dperiodiAmmtoPfKey, 
	 sequIdPeriodoAmmtoPf, Date dataInizioPianificazione, Date dataFinePianificazione, String flagNessunaRichiestaFerie, Long fkPianificFerieAmmto, String flagEliminato, String utenteUltimaModifica, Date dataUltimaModifica, Date dataInizioRecord, Date dataFineRecord)
	{
		super();
		
		this.dperiodiAmmtoPfKey = dperiodiAmmtoPfKey;
	
		this.sequIdPeriodoAmmtoPf = sequIdPeriodoAmmtoPf;
		this.dataInizioPianificazione = dataInizioPianificazione;
		this.dataFinePianificazione = dataFinePianificazione;
		this.flagNessunaRichiestaFerie = flagNessunaRichiestaFerie;
		this.fkPianificFerieAmmto = fkPianificFerieAmmto;
		this.flagEliminato = flagEliminato;
		this.utenteUltimaModifica = utenteUltimaModifica;
		this.dataUltimaModifica = dataUltimaModifica;
		this.dataInizioRecord = dataInizioRecord;
		this.dataFineRecord = dataFineRecord;
		}
	
	
	// CHILDREN
	

	// PARENTS
	@NotNull
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonBackReference("theDpianificFerieAmmto")
	@JsonIgnoreProperties(value = {"hibernateLazyInitializer", "handler"}, allowSetters = true)
	private DpianificFerieAmmto theDpianificFerieAmmto;

	// GETTER/SETTER
	/**
	 * @return the sequIdPeriodoAmmtoPf
	 */
	public  getSequIdPeriodoAmmtoPf() {
	    return this.sequIdPeriodoAmmtoPf;
	}

	/**
	 * @param sequIdPeriodoAmmtoPf to set
	 */
	public void setSequIdPeriodoAmmtoPf( sequIdPeriodoAmmtoPf) {
	    this.sequIdPeriodoAmmtoPf = sequIdPeriodoAmmtoPf;
	}

	/**
	 * @return the dataInizioPianificazione
	 */
	public Date getDataInizioPianificazione() {
		return this.dataInizioPianificazione;
	}

	/**
	 * @param dataInizioPianificazione to set
	 */
	public void setDataInizioPianificazione(Date dataInizioPianificazione) {
		this.dataInizioPianificazione = dataInizioPianificazione;
	}

	/**
	 * @return the dataFinePianificazione
	 */
	public Date getDataFinePianificazione() {
		return this.dataFinePianificazione;
	}

	/**
	 * @param dataFinePianificazione to set
	 */
	public void setDataFinePianificazione(Date dataFinePianificazione) {
		this.dataFinePianificazione = dataFinePianificazione;
	}

	/**
	 * @return the flagNessunaRichiestaFerie
	 */
	public String getFlagNessunaRichiestaFerie() {
		return this.flagNessunaRichiestaFerie;
	}

	/**
	 * @param flagNessunaRichiestaFerie to set
	 */
	public void setFlagNessunaRichiestaFerie(String flagNessunaRichiestaFerie) {
		this.flagNessunaRichiestaFerie = flagNessunaRichiestaFerie;
	}

	/**
	 * @return the fkPianificFerieAmmto
	 */
	public Long getFkPianificFerieAmmto() {
		return this.fkPianificFerieAmmto;
	}

	/**
	 * @param fkPianificFerieAmmto to set
	 */
	public void setFkPianificFerieAmmto(Long fkPianificFerieAmmto) {
		this.fkPianificFerieAmmto = fkPianificFerieAmmto;
	}

	/**
	 * @return the flagEliminato
	 */
	public String getFlagEliminato() {
		return this.flagEliminato;
	}

	/**
	 * @param flagEliminato to set
	 */
	public void setFlagEliminato(String flagEliminato) {
		this.flagEliminato = flagEliminato;
	}

	/**
	 * @return the utenteUltimaModifica
	 */
	public String getUtenteUltimaModifica() {
		return this.utenteUltimaModifica;
	}

	/**
	 * @param utenteUltimaModifica to set
	 */
	public void setUtenteUltimaModifica(String utenteUltimaModifica) {
		this.utenteUltimaModifica = utenteUltimaModifica;
	}

	/**
	 * @return the dataUltimaModifica
	 */
	public Date getDataUltimaModifica() {
		return this.dataUltimaModifica;
	}

	/**
	 * @param dataUltimaModifica to set
	 */
	public void setDataUltimaModifica(Date dataUltimaModifica) {
		this.dataUltimaModifica = dataUltimaModifica;
	}

	/**
	 * @return the dataInizioRecord
	 */
	public Date getDataInizioRecord() {
		return this.dataInizioRecord;
	}

	/**
	 * @param dataInizioRecord to set
	 */
	public void setDataInizioRecord(Date dataInizioRecord) {
		this.dataInizioRecord = dataInizioRecord;
	}

	/**
	 * @return the dataFineRecord
	 */
	public Date getDataFineRecord() {
		return this.dataFineRecord;
	}

	/**
	 * @param dataFineRecord to set
	 */
	public void setDataFineRecord(Date dataFineRecord) {
		this.dataFineRecord = dataFineRecord;
	}

	// CHILD GETTER/SETTER

	/// ADD CHILD

	// PARENT GETTER/SETTER
	/**
	 * @return the DpianificFerieAmmto
	 */
	@JsonProperty(access = Access.WRITE_ONLY)
	public DpianificFerieAmmto getTheDpianificFerieAmmto() {
		return theDpianificFerieAmmto;
	}

	/**
	 * @param aDpianificFerieAmmtoList to set
	 */
	public void setTheDpianificFerieAmmto(DpianificFerieAmmto aDpianificFerieAmmto) {
		theDpianificFerieAmmto = aDpianificFerieAmmto;
	}

	// PARENT ID GETTER/SETTER
	/**
	 * Return the dpianificFerieAmmtoKey from theDpianificFerieAmmto.
	 * 
	 * @return dpianificFerieAmmtoKey from theDpianificFerieAmmto.
	 */
	@JsonProperty
	public DpianificFerieAmmtoKey getDpianificFerieAmmtoKey() {
		// If the parent entity object is null, then return null
		if (getTheDpianificFerieAmmto() == null) {
			return null;
		}
		// Return requested attribute
		return theDpianificFerieAmmto.getDpianificFerieAmmtoKey();
	}

	// PARENT OBJECT TITLE
	/**
	 * Return the object title of theDpianificFerieAmmto.
	 * 
	 * @return the object title of theDpianificFerieAmmto.
	 */
	@JsonProperty
	public String getTheDpianificFerieAmmtoObjectTitle() {
		return getTheDpianificFerieAmmto() != null ? getTheDpianificFerieAmmto().getObjectTitle() : null;
	}

	// PARENT OBJECT KEY
	/**
	 * Return the object key of theDpianificFerieAmmto.
	 * 
	 * @return the object key of theDpianificFerieAmmto.
	 */
	@JsonProperty
	public String getTheDpianificFerieAmmtoObjectKey() {
		return getTheDpianificFerieAmmto() != null ? getTheDpianificFerieAmmto().getObjectKey() : null;
	}

	/**
	 * Set object key of theDpianificFerieAmmto.
	 * 
	 */
	@JsonProperty
	public void setTheDpianificFerieAmmtoObjectKey(String objectKey) {
		if (EntityUtils.isValueChanged(getTheDpianificFerieAmmtoObjectKey(), objectKey, false)) {
			DpianificFerieAmmto dpianificFerieAmmto = new DpianificFerieAmmto();
			dpianificFerieAmmto.setObjectKey(objectKey);
			setTheDpianificFerieAmmto(dpianificFerieAmmto);
		}
	}

	// IMPORTED PARENT OBJECT KEY

	// OPERATIONS

	// OBJECT KEY
	/**
	 * Restituisce l'identificativo della chiave in formato stringa. Ritorna
	 * conveniente nelle selezioni da lista.
	 * 
	 * @return L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public String getObjectKey() {
		return getObjectKeyById(getDperiodiAmmtoPfKey());
	}

	public String getObjectKeyById(DperiodiAmmtoPfKey identification) {
		if (identification == null) {
			return null;
		}
		StringBuilder output = new StringBuilder();
		return output.toString();
	}

	/**
	 * Inizializza la parte identificativa del bean in base alla stringa tokenizzata
	 * da "||" fornita in input.
	 * 
	 * @param key L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public void setObjectKey(String key) {
		if (key == null || key.trim().length() == 0) {
			return;
		}
		String[] array = StringUtils.splitByWholeSeparatorPreserveAllTokens(key, getRowIdFieldDelimiter());
		int ctr = 0;

		dperiodiAmmtoPfKey = new DperiodiAmmtoPfKey();
	}

	// OBJECT TITLE
	public String getObjectTitle() {
		StringBuilder output = new StringBuilder();
		output.append(get());
		return output.toString();
	}

	// COMPOSITE PRIMARY KEY
	@EmbeddedId
	private DperiodiAmmtoPfKey dperiodiAmmtoPfKey;

	// GETTER/SETTER CK
	/**
	 * @return the dperiodiAmmtoPfKey
	 */
	public DperiodiAmmtoPfKey getDperiodiAmmtoPfKey() {
		return this.dperiodiAmmtoPfKey;
	}

	/**
	 * @param dperiodiAmmtoPfKey to set
	 */
	public void setDperiodiAmmtoPfKey(DperiodiAmmtoPfKey dperiodiAmmtoPfKey) {
		this.dperiodiAmmtoPfKey = dperiodiAmmtoPfKey;
	}

	// COMPOSITE KEY CLASS

	// PREPERSIST
	public void syncCK() {
		if (dperiodiAmmtoPfKey == null) {
			dperiodiAmmtoPfKey = new DperiodiAmmtoPfKey();
		}
	}

	@PrePersist
	public void prePersist() {
		syncCK();
	}

	@PreUpdate
	public void PreUpdate() {
		syncCK();
	}

	// Equals / HashCode
	@Override
	public boolean equals(Object o) {
		if (this == o)
			return true;
		if (o == null || Hibernate.getClass(this) != Hibernate.getClass(o))
			return false;
		DperiodiAmmtoPf that = (DperiodiAmmtoPf) o;
		return dperiodiAmmtoPfKey != null && Objects.equals(dperiodiAmmtoPfKey, that.dperiodiAmmtoPfKey);
	}

	@Override
	public int hashCode() {
		return Objects.hash(dperiodiAmmtoPfKey);
	}
}
